<template>
  <div class="common-main theme-wrapper telegram" layout="main" theme-color="main_luxury" data-device="mobile">
    <header-title v-if="allowTheme" :title="$t('bet_history')" :isShowBtn="false"/>
    <div class="w-full relative h-full flex justify-center items-center" v-if="availableTabs.length <= 0">
      <utils-not-found />
    </div>
    <template v-else>
      <div class="flex flex-col bg-background2">
        <el-tabs v-model="activeTab">
          <div class="p-3 bg-background2 setting-tab">
            <div class="flex flex-row gap-3 inputElement">
              <div :class="isSportType ? 'basis-1/2' : 'w-full'">
                <el-select
                  v-model="selectedProvider"
                  class="w-full font-bold"
                  :disabled="disableSelect"
                  @change="onMobileFilterChange"
                >
                  <el-option
                    v-for="provider in gameProviders"
                    :key="provider.GameProviderName"
                    :label="provider.GameProviderName"
                    :value="provider.GameProviderId"
                  >
                    <div class="flex justify-between w-full">
                      <div class="flex items-center">
                        <div>
                          {{ provider.GameProviderName }}
                        </div>
                        <div
                          v-if="themeColor.Text === 'bk8'"
                          class="w-[16px] ml-[11px] currency-check-icon hidden"
                        >
                          <font-awesome-icon icon="circle-check" />
                        </div>
                      </div>
                    </div>
                  </el-option>
                </el-select>
              </div>
              <div v-show="isSportType" class="basis-1/2">
                <el-select
                  v-model="selectedSportStatus"
                  class="w-full font-bold"
                  @change="onMobileFilterChange"
                >
                  <el-option
                    v-for="(item, index) in allSportStatus"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                    <div class="flex justify-between w-full">
                      <div class="flex items-center">
                        <div>
                          {{ item }}
                        </div>
                        <div
                          v-if="themeColor.Text === 'bk8'"
                          class="w-[16px] ml-[11px] currency-check-icon hidden"
                        >
                          <font-awesome-icon icon="circle-check" />
                        </div>
                      </div>
                    </div>
                  </el-option>
                </el-select>
              </div>
            </div>
            <div v-show="selectedSportStatus === 'Settled' || !isSportType">
              <div class="flex items-center justify-center w-full gap-5 mt-2">
                <select-date-radio
                  v-model:startDay="selectedStartDate"
                  v-model:endDay="selectedEndDate"
                  @change="onMobileFilterChange"
                />
              </div>
            </div>
          </div>
          <el-tab-pane :label="$t('sports')" :name="BET_HISTORY_TAB.SPORT" v-if="availableTabs.includes('sports')">
            <lazy-mobile-bet-details-sport-bet
              v-loading="isLoading"
              :is-settled="isSettled"
              :sport-bet="sportBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane
            :label="$t('virtual_sports')"
            :name="BET_HISTORY_TAB.VIRTUAL_SPORT"
            v-if="availableTabs.includes('virtual_sports')">
            <lazy-mobile-bet-details-sport-bet
              v-loading="isLoading"
              :is-settled="isSettled"
              :sport-bet="sportBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane :label="$t('live_casino')" :name="BET_HISTORY_TAB.CASINO" v-if="availableTabs.includes('live_casino')">
            <lazy-mobile-bet-details-game-bet
              v-loading="isLoading"
              :game-bet-list="gameBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane :label="$t('games')" :name="BET_HISTORY_TAB.GAME_BET"
            v-if="availableTabs.includes('games')">
            <lazy-mobile-bet-details-game-bet
              v-loading="isLoading"
              :game-bet-list="gameBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane :label="$t('cock_fight')" :name="BET_HISTORY_TAB.COCKFIGHT"
            v-if="availableTabs.includes('cock_fight')">
            <lazy-mobile-bet-details-game-bet
              v-loading="isLoading"
              :game-bet-list="gameBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane :label="$t('poker')" :name="BET_HISTORY_TAB.POKER"
            v-if="availableTabs.includes('poker')">
            <lazy-mobile-bet-details-game-bet
              v-loading="isLoading"
              :game-bet-list="gameBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
          <el-tab-pane :label="$t('lottery')" :name="BET_HISTORY_TAB.LOTTERY"
            v-if="availableTabs.includes('lottery')">
            <lazy-mobile-bet-details-game-bet
              v-loading="isLoading"
              :game-bet-list="gameBetListDisplay"
              :on-display-bet-detail="onDisplayBetDetail"
            />
          </el-tab-pane>
        </el-tabs>
      </div>
      <el-backtop :right="10" :bottom="10">
        <div
          class="bg-secondary w-[32px] h-[32px] flex items-center justify-center rounded"
        >
          <font-awesome-icon class="text-white" icon="arrow-up" />
        </div>
      </el-backtop>
    </template>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import _ from "lodash";
import HeaderTitle from "@/components/new-black-theme/m-header-title.client.vue";
import { ISportBet, SportBet } from "@/models/sportbet/sportbet";
import { ISeamlessGameBet, SeamlessGameBet } from "@/models/seamlessGameBets";
import { store } from "~~/store";

export default defineComponent({
  name: "BetHistory",
  components: {
    HeaderTitle,
  },
  setup() {
    const {
      activeTab,
      isLoading,
      sportBetList,
      selectedProvider,
      gameProviders,
      gameBetList,
      selectedSportStatus,
      allSportStatus,
      selectedStartDate,
      selectedEndDate,
      onSearch,
      isSportType,
      currentPage,
      disableSelect,
      onDisplayBetDetail,
      isSettled,
      allTabs,
    } = useBetHistory();
    const gameBetByPaging = ref([] as ISeamlessGameBet[]);
    const sportBetByPaging = ref([] as ISportBet[]);
    const sportMaxPage = computed(
      () => _.first(sportBetList.value)?.MaxPage ?? 0
    );
    const gameMaxPage = computed(
      () => _.first(gameBetList.value)?.MaxPage ?? 0
    );
    watch(activeTab, () => {
      window.scrollTo(0, 0);
      sportBetByPaging.value = [];
      gameBetByPaging.value = [];
      currentPage.value = 1;
    });
    const onMobileFilterChange = () => {
      window.scrollTo(0, 0);
      sportBetByPaging.value = [];
      gameBetByPaging.value = [];
      currentPage.value = 1;
      onSearch();
    };

    window.onscroll = function () {
      const scrollTop =
        document.documentElement.scrollTop || document.body.scrollTop;
      const windowHeight =
        document.documentElement.clientHeight || document.body.clientHeight;
      const scrollHeight =
        document.documentElement.scrollHeight || document.body.scrollHeight;
      if (
        scrollTop + windowHeight === scrollHeight ||
        scrollHeight - (scrollTop + windowHeight) < 1
      ) {
        const maxPage = isSportType.value
          ? sportMaxPage.value
          : gameMaxPage.value;
        if (maxPage > currentPage.value) {
          currentPage.value += 1;
        }
      }
    };
    watch(sportBetList, () => {
      sportBetByPaging.value = sportBetByPaging.value.concat(
        sportBetList.value
      );
    });
    watch(gameBetList, () => {
      gameBetByPaging.value = gameBetByPaging.value.concat(gameBetList.value);
    });
    const arrayTheme = ["main", "black", "sbo", 'global', 'playful'];
    const allowTheme = computed(() =>
      arrayTheme.includes(store.state.selectedThemeName)
    );
    const sportBetListDisplay = computed(() =>
      sportBetList.value.map((sb) => new SportBet(sb))
    );
    const gameBetListDisplay = computed(() =>
      gameBetList.value.map((gb) => new SeamlessGameBet(gb))
    );
    const { themeColor } = themePropertyHelper;
    const themeName = store.state.selectedThemeName;
    const availableTabs = computed(()=>allTabs.value.map((tabInfo) => tabInfo.TabLanguage));
    return {
      activeTab,
      isLoading,
      selectedProvider,
      gameProviders,
      selectedSportStatus,
      allSportStatus,
      selectedStartDate,
      selectedEndDate,
      isSportType,
      sportBetByPaging,
      gameBetByPaging,
      onMobileFilterChange,
      onDisplayBetDetail,
      disableSelect,
      allowTheme,
      sportBetListDisplay,
      gameBetListDisplay,
      isSettled,
      themeColor,
      themeName,
      availableTabs,
    };
  },
});
</script>
<style scoped lang="postcss">
:deep(.el-tabs__header) {
  @apply fixed w-full px-0;
  z-index: 10;
  background: var(--background1);
}
:deep(.el-tabs__content) {
  @apply pt-3;
  margin-top: 35px;
  padding-top: 0.75rem;
  overflow: auto;
  height: calc(100vh - 87px);
  padding-bottom: 6rem;
}
:deep(.el-tabs__nav-wrap::after) {
  height: 0px;
}
.setting-tab {
  @apply w-full;
  z-index: 10;
  position: unset;
  top: 84px;
}
.el-tabs__nav-next,
.el-tabs__nav-prev {
  display: none;
}

:deep(.el-tabs__nav-scroll) {
  overflow-x: auto;
}
:deep(.el-tabs__nav-next) {
  display: none;
}
:deep(.el-tabs__nav-prev) {
  display: none;
}
.el-backtop {
  background-color: transparent;
  box-shadow: none;
}
:deep(.el-input__wrapper) {
  width: 100%;
}
.selected .currency-check-icon {
  display: block !important;
}
:deep(.el-tabs__item.is-active, .el-tabs__active-bar) {
  color: var(--secondary);
}
</style>
<style>
.telegram .el-tabs__item {
  font-size: 14px;
  line-height: 46px;
  height: 46px;
  padding: 0 14px;
}
.telegram .el-input__inner {
    height: 48px !important;
    border-radius: 8px;
}
[layout="modern"] .el-tabs__header {
  top: 0;
}
[theme-color="bk8"] .el-select .el-input .el-select__caret{
  color: var(--text) !important;
  stroke: black;
  stroke-width: 70;
}
@media (max-width: 639px) {
  .peru-tab .el-tabs__nav {
    height: 45px;
  }
  .peru-tab .el-tabs__header.is-top {
    position: relative;
    padding: 5px 20px;
  }
  .peru-tab .el-tabs__header.is-top:before {
    background: #505451;
    bottom: 4px;
    content: "";
    height: 2px;
    left: 0;
    position: absolute;
    width: 100%;
  }
}
</style>